#ifndef __BUSS_H
#define __BUSS_H

#include <fstream>
#include <iostream>
#include <string>
#include <vector>

#include "konstanter.h"
#include "lesData3.h"
#include "rute.h"

class Buss : public Rute {
   private:
    int antallSitteplasser;
    int antallStaplasser;
    bool leddbuss;
    HjelpeFunksjoner hjelp;

   public:
    Buss();
    virtual ~Buss();
    void lesData();
    void skrivData();
    void skrivDataForlengs();
    void skrivDataBaklengs();
    void skrivType();
    void lesFraFil(std::ifstream& inn);
    void skrivTilFil(std::ofstream& ut);
};

#endif  //__BUSS_H