#include "stoppested.h"

using namespace std;

// extern Stoppesteder* gStoppesteder;

Stoppested::Stoppested() {
    navn = "";
}

Stoppested::Stoppested(const string& navn, const bool& leggeTilTid) {
    this->navn = navn;
}

Stoppested::Stoppested(const int& index, const string& navn) {
    this->navn = navn;
    // leggTilIndex()
}

Stoppested::~Stoppested() {
}

string Stoppested::hentNavn() {
    return navn;
}

void Stoppested::lesData() {
    /*string inn;
    cout << "\nSkriv inn navn på stoppested (blankt for avbryt):";
    getline(cin, inn);
    inn = hjelp.rensStreng(inn);
    if (!inn.empty()) {
        if (gStoppesteder->hentEksisterende(inn) == nullptr)
            navn = inn;
        else
            cout << "\nError: Stoppested eksisterer fra før!" << '\n';
    } else
        cout << "\nAvbryter!" << '\n';*/
}

void Stoppested::skrivData() {
    cout << "\n..::Stoppested info::.."
         << "\nNavn: " << navn << '\n';
}

void Stoppested::skrivDataMedNaboer(vector<Stoppested*> alleStoppesteder) {
    skrivData();
    int i, pos;
    i = pos = 0;
    bool naboEksisterer = false;
    cout << "\nHar forbindelser til:";  // << '\n';
    for (const auto& val : indexNaboStoppene) {
        cout << "\nSize indexes naboer: " << indexNaboStoppene.size();
        cout << "\nSize tid: " << antallMinutterTilNaboStopp.size();
        if (val < alleStoppesteder.size()) {
            pos++;
            cout << "\n\t" << i + pos << " - Navn: " << alleStoppesteder[val]->hentNavn()
                 << '\t'
                 << "Tid i minutter mellom stopp: " << antallMinutterTilNaboStopp[i];
            //<< '\n';
            naboEksisterer = true;            
        }
        i++;
    }
    if (!naboEksisterer) cout << "\nIngen forbindelser registrert!" << '\n';
}

int Stoppested::hentTidNaboStopp() {
    int storrelse = antallMinutterTilNaboStopp.size();
    if (storrelse > 0) {
        return antallMinutterTilNaboStopp.back();
    }
    return -1;
}

int Stoppested::hentIndex() {
    if (indexNaboStoppene.size() > 0)
        return indexNaboStoppene.back();
    return -1;
}

void Stoppested::leggTilNaboStopp(const int& index, const int& minutter) {
    leggTilIndex(index);
    leggTilTid(minutter);
}

void Stoppested::lesTid() {
    int minutter;
    minutter = lesInt("Tid mellom forrige stopp i minutter", MIN_MINUTTER, MAX_MINUTTER);
    leggTilTid(minutter);
    // todo
}

void Stoppested::leggTilIndex(const int& index) {
    indexNaboStoppene.push_back(index);
}

void Stoppested::leggTilTid(const int& minutter) {
    antallMinutterTilNaboStopp.push_back(minutter);
}

void Stoppested::slettVectorer() {
    indexNaboStoppene.clear();
    antallMinutterTilNaboStopp.clear();
}

void Stoppested::fjernForsteNabo() {
    int tmpIndex, tmpTid;
    if (indexNaboStoppene.size() > 0 &&
        antallMinutterTilNaboStopp.size() > 0) {
        tmpIndex = indexNaboStoppene.back();
        tmpTid = antallMinutterTilNaboStopp.back();
        slettVectorer();
        indexNaboStoppene.push_back(tmpIndex);
        antallMinutterTilNaboStopp.push_back(tmpTid);
    }
}

void Stoppested::fjernSisteNabo() {
    if (indexNaboStoppene.size() > 1 &&
        antallMinutterTilNaboStopp.size() > 1) {
        indexNaboStoppene.pop_back();
        antallMinutterTilNaboStopp.pop_back();
    }
}

void Stoppested::leggTilNaboFremst(const int& index, const int& tid) {
    fjernForsteNabo();
    int tmpIndex, tmpTid;
    tmpIndex = tmpTid = -1;
    if (indexNaboStoppene.size() > 0 &&
        antallMinutterTilNaboStopp.size() > 0) {
        tmpIndex = indexNaboStoppene.back();
        tmpTid = antallMinutterTilNaboStopp.back();
        indexNaboStoppene.pop_back();
        antallMinutterTilNaboStopp.pop_back();
    }
    leggTilNaboStopp(index, tid);
    if (tmpIndex >= 0 && tmpTid >= 0) leggTilNaboStopp(tmpIndex, tmpTid);
}

void Stoppested::leggTilNaboBakerst(const int& index, const int& tid) {
    fjernSisteNabo();
    leggTilNaboStopp(index, tid);
}

int Stoppested::hentNaboStoppIndex(const bool& siste) {
    if (indexNaboStoppene.size() > 1 && !siste)
        return indexNaboStoppene.front();
    else if (indexNaboStoppene.size() > 0 && siste) {
        return indexNaboStoppene.back();
    }
    return -1;
}

int Stoppested::hentAntallStoppestedVector() {
    if (indexNaboStoppene.size() > 1)
        return indexNaboStoppene.size();
    return -1;
}

int Stoppested::hentTidForsteNabo() {
    if (antallMinutterTilNaboStopp.size() > 1)
        return antallMinutterTilNaboStopp.front();
    return -1;
}

void Stoppested::lesFraFil(ifstream& inn) {
    string heleLinjen = "";
    getline(inn, heleLinjen);
    int pos = 0;
    vector<string> linjenSplittet = hjelp.splittStreng('*', heleLinjen);
    int storrelse = linjenSplittet.size();
    cout << "\nStorrelse splittet: " << storrelse << "\n\n";
    for (int i = 0; i < storrelse - 1; i++) {
        switch (i) {
            case 0:
                navn = linjenSplittet[0];
                break;
            case 1:
                indexNaboStoppene.push_back(stoi(linjenSplittet[1]));
                break;
            case 2: {
                if (storrelse > 5)
                    indexNaboStoppene.push_back(stoi(linjenSplittet[2]));
                else
                    antallMinutterTilNaboStopp.push_back(stoi(linjenSplittet[2]));
                break;
            }
            case 3:
                antallMinutterTilNaboStopp.push_back(stoi(linjenSplittet[3]));
                break;
            case 4:
                antallMinutterTilNaboStopp.push_back(stoi(linjenSplittet[4]));
                break;
        }
    }
}

void Stoppested::skrivTilFil(ofstream& ut) {
    ut << navn << '*';
    for (const auto& val : indexNaboStoppene) {
        ut << val << '*';
    }
    for (const auto& val : antallMinutterTilNaboStopp) {
        ut << val << '*';
    }
    ut << '\n';
}