#include "stoppesteder.h"

using namespace std;

Stoppesteder::Stoppesteder() {
}

Stoppesteder::~Stoppesteder() {
    ryddOppMinne();
}

void Stoppesteder::skrivData() {
    int i = 1;
    for (const auto& val : alleStoppesteder) {
        cout << "\n\t" << i << " - " << val->hentNavn();
        i++;
    }
}

void Stoppesteder::skrivSpesifikkData() {
    cout << "\nSkriv inn navnet på stoppestedet: ";
    string inn;
    getline(cin, inn);
    inn = hjelp.rensStreng(inn);
    Stoppested* stopp = hentEksisterende(inn);
    if (stopp != nullptr) {
        stopp->skrivDataMedNaboer(alleStoppesteder);
    } else
        cout << "\nIkke entydig eller finnes ikke!" << '\n';
}

void Stoppesteder::ny(const string& navn, const bool& leggTilTid) {
    // bool eksisterer = false;
    /*vector<Stoppested *>::iterator it =
        find_if(alleStoppesteder.begin(), alleStoppesteder.end(),
                [](Stoppested *s, const string navn) { return s->hentNavn() == navn; });*/

    /*for (const auto & val : alleStoppesteder) {
        if (val->hentNavn() == navn)
            eksisterer = true;

    }*/
    if (hentEksisterende(navn) != nullptr)
        cout << '\n'
             << "Error: "
             << navn
             << " eksisterer allerede!"
             << '\n';
    /* else if (leggTilTid) {
         // tid mellom forrige busstopp
         // tid til neste bussstopp
         // for (int i = alleStoppesteder.size(); i < )
         alleStoppesteder.push_back(new Stoppested(alleStoppesteder.size(), navn, leggTilTid));

     }*/
    else
        alleStoppesteder.push_back(new Stoppested(navn, leggTilTid));
}

Stoppested* Stoppesteder::hentEksisterende(const string& navn) {
    bool lik;
    int antallLike = 0;
    string tmp;
    Stoppested* tmpStoppested = nullptr;
    for (const auto& val : alleStoppesteder) {
        if (hjelp.gjorOmTilStorBokstav(val->hentNavn()) ==
            hjelp.gjorOmTilStorBokstav(navn))
            return val;
        lik = true;
        tmp = "";
        tmp = val->hentNavn();
        for (int i = 0; i < navn.size(); i++) {
            if (i < tmp.size()) {
                if (toupper(navn[i]) != toupper(tmp[i])) lik = false;
            } else
                lik = false;
        }
        if (lik) {
            tmpStoppested = val;
            antallLike++;
        }
    }
    if (antallLike == 1) return tmpStoppested;
    return nullptr;
}
Stoppested* Stoppesteder::hentEksisterende(const int& index) {
    if (alleStoppesteder.size() >= index) return alleStoppesteder[index];
    return nullptr;
}
void Stoppesteder::skrivMeny() {
    /*cout << "\nN - Lag nytt stoppested" << '\n'
         << "A - Skriv alle stoppesteder" << '\n'
         << "E - Skriv alt om ett stoppested" << '\n';*/
    cout << "\nN - Nytt stoppested" << '\n'
         << "A - Skriv alle stoppesteder" << '\n'
         << "E - Skriv alt om ett stoppested" << '\n'
         << "Q - Tilbake";
}

int Stoppesteder::hentIndex(Stoppested* stoppested) {
    int i = 0;
    for (const auto& val : alleStoppesteder) {
        if (val == stoppested) return i;
        i++;
    }
    return -1;
}

void Stoppesteder::meny(const char& valg) {
    // char valg;
    string navn;
    // do {
    // skrivMeny();
    // valg = lesChar("");
    switch (valg) {
        case 'N': {
            cout << "\nSkriv inn navn på stoppested:";
            getline(cin, navn);
            navn = hjelp.rensStreng(navn);
            if (navn != "")
                ny(navn, false);
            break;
        }
        case 'A':
            skrivData();
            break;
        case 'E':
            skrivSpesifikkData();
            break;
        case 'Q':
            break;
        default:
            cout << "\nUgyldig valg!" << '\n';
            break;
    }
    //} while (valg != 'Q');
}

void Stoppesteder::ryddOppMinne() {
    for (int i = 0; i < alleStoppesteder.size(); i++) {
        delete alleStoppesteder[i];
    }
    alleStoppesteder.clear();
}

void Stoppesteder::lesFraFil() {
    int antallStoppesteder, i;
    antallStoppesteder = i = 0;
    ifstream fil(STI_STOPPESTEDER);
    if (fil) {
        fil >> antallStoppesteder;
        fil.ignore();
        while (!fil.eof() && i < antallStoppesteder) {
            alleStoppesteder.push_back(new Stoppested);
            i++;
        }
        fil.close();
    } else
        cout << "Error: " << STI_STOPPESTEDER << " kunne ikke bli funnet!"
             << '\n';
}

void Stoppesteder::skrivTilFil() {
    ofstream fil(STI_STOPPESTEDER);
    fil << alleStoppesteder.size() << '\n';
    for (const auto & val : alleStoppesteder) {
        // skrivTilFil call stoppested.
    }
}